package com.teamdev.jxbrowser.chromium.internal;

import com.teamdev.jxbrowser.chromium.Cookie;
import com.teamdev.jxbrowser.chromium.CookieStorage;
import com.teamdev.jxbrowser.chromium.internal.CookieParser;
import com.teamdev.jxbrowser.chromium.internal.ipc.Channel;
import com.teamdev.jxbrowser.chromium.internal.ipc.message.FlushCookiesMessage;
import com.teamdev.jxbrowser.chromium.internal.ipc.message.GetCookiesMessage;
import com.teamdev.jxbrowser.chromium.internal.ipc.message.ModifyCookiesMessage;
import java.util.List;

public class ChannelCookieStorage implements CookieStorage {

   private final Channel a;


   public ChannelCookieStorage(Channel channel) {
      this.a = channel;
   }

   public synchronized List getAllCookies() {
      return CookieParser.parseCookiesString(((GetCookiesMessage)this.a.post(new GetCookiesMessage())).cookies);
   }

   public synchronized List getAllCookies(String url) {
      GetCookiesMessage var2;
      (var2 = new GetCookiesMessage()).url = url;
      return CookieParser.parseCookiesString(((GetCookiesMessage)this.a.post(var2)).cookies);
   }

   public synchronized boolean delete(Cookie cookie) {
      ModifyCookiesMessage var2;
      (var2 = new ModifyCookiesMessage()).flag = 4;
      var2.cookieName = cookie.getName();
      var2.cookieValue = cookie.getValue();
      var2.cookieDomain = cookie.getDomain();
      var2.cookiePath = cookie.getPath();
      var2.cookieCreationTime = cookie.getCreationTime();
      var2.cookieExpirationTime = cookie.getExpirationTime();
      var2.cookieSecure = cookie.isSecure();
      var2.cookieHttpOnly = cookie.isHTTPOnly();
      return ((ModifyCookiesMessage)this.a.post(var2)).success;
   }

   public synchronized int deleteAll() {
      ModifyCookiesMessage var1;
      (var1 = new ModifyCookiesMessage()).flag = 0;
      return ((ModifyCookiesMessage)this.a.post(var1)).numDeleted;
   }

   public synchronized boolean setCookie(String url, String name, String value, String domain, String path, long expirationTimeInMicroseconds, boolean secure, boolean httpOnly) {
      ModifyCookiesMessage var10;
      (var10 = new ModifyCookiesMessage()).flag = 5;
      var10.host = url;
      var10.cookieName = name;
      var10.cookieValue = value;
      var10.cookieDomain = domain;
      var10.cookiePath = path;
      var10.cookieExpirationTime = expirationTimeInMicroseconds;
      var10.cookieSecure = secure;
      var10.cookieHttpOnly = httpOnly;
      return ((ModifyCookiesMessage)this.a.post(var10)).success;
   }

   public synchronized boolean setSessionCookie(String url, String name, String value, String domain, String path, boolean secure, boolean httpOnly) {
      return this.setCookie(url, name, value, domain, path, 0L, secure, httpOnly);
   }

   public synchronized void save() {
      this.a.post(new FlushCookiesMessage());
   }
}
